/*
 * obj/x86_64-unknown-linux-gnu/xrl/interfaces/common_xif.cc
 * vim:set sts=4 ts=8 ft=cpp:
 *
 * Copyright (c) 2001-2011 XORP, Inc and Others
 * See the XORP LICENSE.lgpl file for licensing, conditions, and warranties
 * on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'clnt-gen'.
 */

#include "common_xif.hh"

bool
XrlCommonV0p1Client::send_get_target_name(
	const char*	dst_xrl_target_name,
	const GetTargetNameCB&	cb
)
{
    Xrl* x = ap_xrl_get_target_name.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "common/0.1/get_target_name");
        ap_xrl_get_target_name.reset(x);
    }

    x->set_target(dst_xrl_target_name);


    return _sender->send(*x, callback(&XrlCommonV0p1Client::unmarshall_get_target_name, cb));
}


/* Unmarshall get_target_name */
void
XrlCommonV0p1Client::unmarshall_get_target_name(
	const XrlError&	e,
	XrlArgs*	a,
	GetTargetNameCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e, 0);
	return;
    } else if (a && a->size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(1));
	cb->dispatch(XrlError::BAD_ARGS(), 0);
	return;
    }
    string name;
    try {
	a->get("name", name);
    } catch (const XrlArgs::BadArgs& bad_args_err) {
	UNUSED(bad_args_err)
	XLOG_ERROR("Error decoding the arguments: %s", bad_args_err.str().c_str());
	cb->dispatch(XrlError::BAD_ARGS(), 0);
	return;
    }
    cb->dispatch(e, &name);
}

bool
XrlCommonV0p1Client::send_get_version(
	const char*	dst_xrl_target_name,
	const GetVersionCB&	cb
)
{
    Xrl* x = ap_xrl_get_version.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "common/0.1/get_version");
        ap_xrl_get_version.reset(x);
    }

    x->set_target(dst_xrl_target_name);


    return _sender->send(*x, callback(&XrlCommonV0p1Client::unmarshall_get_version, cb));
}


/* Unmarshall get_version */
void
XrlCommonV0p1Client::unmarshall_get_version(
	const XrlError&	e,
	XrlArgs*	a,
	GetVersionCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e, 0);
	return;
    } else if (a && a->size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(1));
	cb->dispatch(XrlError::BAD_ARGS(), 0);
	return;
    }
    string version;
    try {
	a->get("version", version);
    } catch (const XrlArgs::BadArgs& bad_args_err) {
	UNUSED(bad_args_err)
	XLOG_ERROR("Error decoding the arguments: %s", bad_args_err.str().c_str());
	cb->dispatch(XrlError::BAD_ARGS(), 0);
	return;
    }
    cb->dispatch(e, &version);
}

bool
XrlCommonV0p1Client::send_get_status(
	const char*	dst_xrl_target_name,
	const GetStatusCB&	cb
)
{
    Xrl* x = ap_xrl_get_status.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "common/0.1/get_status");
        ap_xrl_get_status.reset(x);
    }

    x->set_target(dst_xrl_target_name);


    return _sender->send(*x, callback(&XrlCommonV0p1Client::unmarshall_get_status, cb));
}


/* Unmarshall get_status */
void
XrlCommonV0p1Client::unmarshall_get_status(
	const XrlError&	e,
	XrlArgs*	a,
	GetStatusCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e, 0, 0);
	return;
    } else if (a && a->size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(2));
	cb->dispatch(XrlError::BAD_ARGS(), 0, 0);
	return;
    }
    uint32_t status;
    string reason;
    try {
	a->get("status", status);
	a->get("reason", reason);
    } catch (const XrlArgs::BadArgs& bad_args_err) {
	UNUSED(bad_args_err)
	XLOG_ERROR("Error decoding the arguments: %s", bad_args_err.str().c_str());
	cb->dispatch(XrlError::BAD_ARGS(), 0, 0);
	return;
    }
    cb->dispatch(e, &status, &reason);
}

bool
XrlCommonV0p1Client::send_shutdown(
	const char*	dst_xrl_target_name,
	const ShutdownCB&	cb
)
{
    Xrl* x = ap_xrl_shutdown.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "common/0.1/shutdown");
        ap_xrl_shutdown.reset(x);
    }

    x->set_target(dst_xrl_target_name);


    return _sender->send(*x, callback(&XrlCommonV0p1Client::unmarshall_shutdown, cb));
}


/* Unmarshall shutdown */
void
XrlCommonV0p1Client::unmarshall_shutdown(
	const XrlError&	e,
	XrlArgs*	a,
	ShutdownCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlCommonV0p1Client::send_startup(
	const char*	dst_xrl_target_name,
	const StartupCB&	cb
)
{
    Xrl* x = ap_xrl_startup.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "common/0.1/startup");
        ap_xrl_startup.reset(x);
    }

    x->set_target(dst_xrl_target_name);


    return _sender->send(*x, callback(&XrlCommonV0p1Client::unmarshall_startup, cb));
}


/* Unmarshall startup */
void
XrlCommonV0p1Client::unmarshall_startup(
	const XrlError&	e,
	XrlArgs*	a,
	StartupCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}
