/*
 * obj/x86_64-unknown-linux-gnu/xrl/interfaces/finder_event_observer_xif.cc
 * vim:set sts=4 ts=8 ft=cpp:
 *
 * Copyright (c) 2001-2011 XORP, Inc and Others
 * See the XORP LICENSE.lgpl file for licensing, conditions, and warranties
 * on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'clnt-gen'.
 */

#include "finder_event_observer_xif.hh"

bool
XrlFinderEventObserverV0p1Client::send_xrl_target_birth(
	const char*	dst_xrl_target_name,
	const string&	target_class,
	const string&	target_instance,
	const XrlTargetBirthCB&	cb
)
{
    Xrl* x = ap_xrl_xrl_target_birth.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "finder_event_observer/0.1/xrl_target_birth");
        x->args().add("target_class", target_class);
        x->args().add("target_instance", target_instance);
        ap_xrl_xrl_target_birth.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, target_class);
    x->args().set_arg(1, target_instance);

    return _sender->send(*x, callback(&XrlFinderEventObserverV0p1Client::unmarshall_xrl_target_birth, cb));
}


/* Unmarshall xrl_target_birth */
void
XrlFinderEventObserverV0p1Client::unmarshall_xrl_target_birth(
	const XrlError&	e,
	XrlArgs*	a,
	XrlTargetBirthCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlFinderEventObserverV0p1Client::send_xrl_target_death(
	const char*	dst_xrl_target_name,
	const string&	target_class,
	const string&	target_instance,
	const XrlTargetDeathCB&	cb
)
{
    Xrl* x = ap_xrl_xrl_target_death.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "finder_event_observer/0.1/xrl_target_death");
        x->args().add("target_class", target_class);
        x->args().add("target_instance", target_instance);
        ap_xrl_xrl_target_death.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, target_class);
    x->args().set_arg(1, target_instance);

    return _sender->send(*x, callback(&XrlFinderEventObserverV0p1Client::unmarshall_xrl_target_death, cb));
}


/* Unmarshall xrl_target_death */
void
XrlFinderEventObserverV0p1Client::unmarshall_xrl_target_death(
	const XrlError&	e,
	XrlArgs*	a,
	XrlTargetDeathCB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}
