/*
 * obj/x86_64-unknown-linux-gnu/xrl/interfaces/mld6igmp_client_xif.cc
 * vim:set sts=4 ts=8 ft=cpp:
 *
 * Copyright (c) 2001-2011 XORP, Inc and Others
 * See the XORP LICENSE.lgpl file for licensing, conditions, and warranties
 * on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'clnt-gen'.
 */

#include "mld6igmp_client_xif.hh"

bool
XrlMld6igmpClientV0p1Client::send_add_membership4(
	const char*	dst_xrl_target_name,
	const string&	xrl_sender_name,
	const string&	vif_name,
	const uint32_t&	vif_index,
	const IPv4&	source,
	const IPv4&	group,
	const AddMembership4CB&	cb
)
{
    Xrl* x = ap_xrl_add_membership4.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "mld6igmp_client/0.1/add_membership4");
        x->args().add("xrl_sender_name", xrl_sender_name);
        x->args().add("vif_name", vif_name);
        x->args().add("vif_index", vif_index);
        x->args().add("source", source);
        x->args().add("group", group);
        ap_xrl_add_membership4.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, xrl_sender_name);
    x->args().set_arg(1, vif_name);
    x->args().set_arg(2, vif_index);
    x->args().set_arg(3, source);
    x->args().set_arg(4, group);

    return _sender->send(*x, callback(&XrlMld6igmpClientV0p1Client::unmarshall_add_membership4, cb));
}


/* Unmarshall add_membership4 */
void
XrlMld6igmpClientV0p1Client::unmarshall_add_membership4(
	const XrlError&	e,
	XrlArgs*	a,
	AddMembership4CB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlMld6igmpClientV0p1Client::send_add_membership6(
	const char*	dst_xrl_target_name,
	const string&	xrl_sender_name,
	const string&	vif_name,
	const uint32_t&	vif_index,
	const IPv6&	source,
	const IPv6&	group,
	const AddMembership6CB&	cb
)
{
    Xrl* x = ap_xrl_add_membership6.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "mld6igmp_client/0.1/add_membership6");
        x->args().add("xrl_sender_name", xrl_sender_name);
        x->args().add("vif_name", vif_name);
        x->args().add("vif_index", vif_index);
        x->args().add("source", source);
        x->args().add("group", group);
        ap_xrl_add_membership6.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, xrl_sender_name);
    x->args().set_arg(1, vif_name);
    x->args().set_arg(2, vif_index);
    x->args().set_arg(3, source);
    x->args().set_arg(4, group);

    return _sender->send(*x, callback(&XrlMld6igmpClientV0p1Client::unmarshall_add_membership6, cb));
}


/* Unmarshall add_membership6 */
void
XrlMld6igmpClientV0p1Client::unmarshall_add_membership6(
	const XrlError&	e,
	XrlArgs*	a,
	AddMembership6CB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlMld6igmpClientV0p1Client::send_delete_membership4(
	const char*	dst_xrl_target_name,
	const string&	xrl_sender_name,
	const string&	vif_name,
	const uint32_t&	vif_index,
	const IPv4&	source,
	const IPv4&	group,
	const DeleteMembership4CB&	cb
)
{
    Xrl* x = ap_xrl_delete_membership4.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "mld6igmp_client/0.1/delete_membership4");
        x->args().add("xrl_sender_name", xrl_sender_name);
        x->args().add("vif_name", vif_name);
        x->args().add("vif_index", vif_index);
        x->args().add("source", source);
        x->args().add("group", group);
        ap_xrl_delete_membership4.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, xrl_sender_name);
    x->args().set_arg(1, vif_name);
    x->args().set_arg(2, vif_index);
    x->args().set_arg(3, source);
    x->args().set_arg(4, group);

    return _sender->send(*x, callback(&XrlMld6igmpClientV0p1Client::unmarshall_delete_membership4, cb));
}


/* Unmarshall delete_membership4 */
void
XrlMld6igmpClientV0p1Client::unmarshall_delete_membership4(
	const XrlError&	e,
	XrlArgs*	a,
	DeleteMembership4CB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}

bool
XrlMld6igmpClientV0p1Client::send_delete_membership6(
	const char*	dst_xrl_target_name,
	const string&	xrl_sender_name,
	const string&	vif_name,
	const uint32_t&	vif_index,
	const IPv6&	source,
	const IPv6&	group,
	const DeleteMembership6CB&	cb
)
{
    Xrl* x = ap_xrl_delete_membership6.get();

    if (!x) {
        x = new Xrl(dst_xrl_target_name, "mld6igmp_client/0.1/delete_membership6");
        x->args().add("xrl_sender_name", xrl_sender_name);
        x->args().add("vif_name", vif_name);
        x->args().add("vif_index", vif_index);
        x->args().add("source", source);
        x->args().add("group", group);
        ap_xrl_delete_membership6.reset(x);
    }

    x->set_target(dst_xrl_target_name);

    x->args().set_arg(0, xrl_sender_name);
    x->args().set_arg(1, vif_name);
    x->args().set_arg(2, vif_index);
    x->args().set_arg(3, source);
    x->args().set_arg(4, group);

    return _sender->send(*x, callback(&XrlMld6igmpClientV0p1Client::unmarshall_delete_membership6, cb));
}


/* Unmarshall delete_membership6 */
void
XrlMld6igmpClientV0p1Client::unmarshall_delete_membership6(
	const XrlError&	e,
	XrlArgs*	a,
	DeleteMembership6CB		cb
)
{
    if (e != XrlError::OKAY()) {
	cb->dispatch(e);
	return;
    } else if (a && a->size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != %u)", XORP_UINT_CAST(a->size()), XORP_UINT_CAST(0));
	cb->dispatch(XrlError::BAD_ARGS());
	return;
    }
    cb->dispatch(e);
}
