/*
 * obj/x86_64-unknown-linux-gnu/xrl/targets/xorpsh_base.hh
 * vim:set sts=4 ts=8 ft=cpp:
 *
 * Copyright (c) 2001-2011 XORP, Inc and Others
 * See the XORP LICENSE.lgpl file for licensing, conditions, and warranties
 * on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 */


#ifndef __XRL_TARGETS_XORPSH_BASE_HH__
#define __XRL_TARGETS_XORPSH_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlXorpshTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrl_cmd_map.hh"

class XrlXorpshTargetBase {
protected:
    XrlCmdMap* _cmds;

public:
    /**
     * Constructor.
     *
     * @param cmds an XrlCmdMap that the commands associated with the target
     *		   should be added to.  This is typically the XrlRouter
     *		   associated with the target.
     */
    XrlXorpshTargetBase(XrlCmdMap* cmds = 0);

    /**
     * Destructor.
     *
     * Dissociates instance commands from command map.
     */
    virtual ~XrlXorpshTargetBase();

    /**
     * Set command map.
     *
     * @param cmds pointer to command map to associate commands with.  This
     * argument is typically a pointer to the XrlRouter associated with the
     * target.
     *
     * @return true on success, false if cmds is null or a command map has
     * already been supplied.
     */
    bool set_command_map(XrlCmdMap* cmds);

    /**
     * Get Xrl instance name associated with command map.
     */
    const string& get_name() const { return _cmds->name(); }

    /**
     * Get version string of instance.
     */
    const char* version() const { return "xorpsh/0.0"; }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values,
	string&	name) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback2<void, const XrlCmdError &,
	const string*>::RefPtr
    Common01GetTargetNameRF;

    class Common01GetTargetNameCB {
        Common01GetTargetNameRF cb;

    public:
        operator const Common01GetTargetNameRF& () const { return cb; }
        const Common01GetTargetNameRF& operator ->() const { return cb; }
        Common01GetTargetNameCB(const Common01GetTargetNameRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e, NULL); }

        void respond(const string& arg_name) const {
            cb->dispatch(XrlCmdError::OKAY(),
                         &arg_name);
        }
    };

    struct Common01GetTargetNameRsp :
      public Common01GetTargetNameCB {
        struct args_str {
            string name;
        };

    private:
        args_str args;

    public:
        Common01GetTargetNameRsp(const Common01GetTargetNameRF& cb)
          : Common01GetTargetNameCB(cb) { }

        void respond() const {
            Common01GetTargetNameCB::
            respond(args.name);
        }

        args_str* operator ->() {
            return &args;
        }
    };

    virtual void async_common_0_1_get_target_name
       (
	Common01GetTargetNameCB);
#endif

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values,
	string&	version) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback2<void, const XrlCmdError &,
	const string*>::RefPtr
    Common01GetVersionRF;

    class Common01GetVersionCB {
        Common01GetVersionRF cb;

    public:
        operator const Common01GetVersionRF& () const { return cb; }
        const Common01GetVersionRF& operator ->() const { return cb; }
        Common01GetVersionCB(const Common01GetVersionRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e, NULL); }

        void respond(const string& arg_version) const {
            cb->dispatch(XrlCmdError::OKAY(),
                         &arg_version);
        }
    };

    struct Common01GetVersionRsp :
      public Common01GetVersionCB {
        struct args_str {
            string version;
        };

    private:
        args_str args;

    public:
        Common01GetVersionRsp(const Common01GetVersionRF& cb)
          : Common01GetVersionCB(cb) { }

        void respond() const {
            Common01GetVersionCB::
            respond(args.version);
        }

        args_str* operator ->() {
            return &args;
        }
    };

    virtual void async_common_0_1_get_version
       (
	Common01GetVersionCB);
#endif

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get status of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_status(
	// Output values,
	uint32_t&	status,
	string&	reason) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback3<void, const XrlCmdError &,
	const uint32_t*,
	const string*>::RefPtr
    Common01GetStatusRF;

    class Common01GetStatusCB {
        Common01GetStatusRF cb;

    public:
        operator const Common01GetStatusRF& () const { return cb; }
        const Common01GetStatusRF& operator ->() const { return cb; }
        Common01GetStatusCB(const Common01GetStatusRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e, NULL, NULL); }

        void respond(const uint32_t& arg_status,
                     const string& arg_reason) const {
            cb->dispatch(XrlCmdError::OKAY(),
                         &arg_status,
                         &arg_reason);
        }
    };

    struct Common01GetStatusRsp :
      public Common01GetStatusCB {
        struct args_str {
            uint32_t status;
            string reason;
        };

    private:
        args_str args;

    public:
        Common01GetStatusRsp(const Common01GetStatusRF& cb)
          : Common01GetStatusCB(cb) { }

        void respond() const {
            Common01GetStatusCB::
            respond(args.status,
                        args.reason);
        }

        args_str* operator ->() {
            return &args;
        }
    };

    virtual void async_common_0_1_get_status
       (
	Common01GetStatusCB);
#endif

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Request clean shutdown of Xrl Target
     */
    virtual XrlCmdError common_0_1_shutdown() = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    Common01ShutdownRF;

    class Common01ShutdownCB {
        Common01ShutdownRF cb;

    public:
        operator const Common01ShutdownRF& () const { return cb; }
        const Common01ShutdownRF& operator ->() const { return cb; }
        Common01ShutdownCB(const Common01ShutdownRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct Common01ShutdownRsp :
      public Common01ShutdownCB {
        Common01ShutdownRsp(const Common01ShutdownRF& cb)
          : Common01ShutdownCB(cb) { }

    };

    virtual void async_common_0_1_shutdown
       (
	Common01ShutdownCB);
#endif

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Request a startup of Xrl Target
     */
    virtual XrlCmdError common_0_1_startup() = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    Common01StartupRF;

    class Common01StartupCB {
        Common01StartupRF cb;

    public:
        operator const Common01StartupRF& () const { return cb; }
        const Common01StartupRF& operator ->() const { return cb; }
        Common01StartupCB(const Common01StartupRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct Common01StartupRsp :
      public Common01StartupCB {
        Common01StartupRsp(const Common01StartupRF& cb)
          : Common01StartupCB(cb) { }

    };

    virtual void async_common_0_1_startup
       (
	Common01StartupCB);
#endif

    virtual XrlCmdError rtrmgr_client_0_2_new_config_user(
	// Input values,
	const uint32_t&	userid) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    RtrmgrClient02NewConfigUserRF;

    class RtrmgrClient02NewConfigUserCB {
        RtrmgrClient02NewConfigUserRF cb;

    public:
        operator const RtrmgrClient02NewConfigUserRF& () const { return cb; }
        const RtrmgrClient02NewConfigUserRF& operator ->() const { return cb; }
        RtrmgrClient02NewConfigUserCB(const RtrmgrClient02NewConfigUserRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct RtrmgrClient02NewConfigUserRsp :
      public RtrmgrClient02NewConfigUserCB {
        RtrmgrClient02NewConfigUserRsp(const RtrmgrClient02NewConfigUserRF& cb)
          : RtrmgrClient02NewConfigUserCB(cb) { }

    };

    virtual void async_rtrmgr_client_0_2_new_config_user
       (
	const uint32_t&	userid,
	RtrmgrClient02NewConfigUserCB);
#endif

    virtual XrlCmdError rtrmgr_client_0_2_config_saved_done(
	// Input values,
	const bool&	success,
	const string&	errmsg) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    RtrmgrClient02ConfigSavedDoneRF;

    class RtrmgrClient02ConfigSavedDoneCB {
        RtrmgrClient02ConfigSavedDoneRF cb;

    public:
        operator const RtrmgrClient02ConfigSavedDoneRF& () const { return cb; }
        const RtrmgrClient02ConfigSavedDoneRF& operator ->() const { return cb; }
        RtrmgrClient02ConfigSavedDoneCB(const RtrmgrClient02ConfigSavedDoneRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct RtrmgrClient02ConfigSavedDoneRsp :
      public RtrmgrClient02ConfigSavedDoneCB {
        RtrmgrClient02ConfigSavedDoneRsp(const RtrmgrClient02ConfigSavedDoneRF& cb)
          : RtrmgrClient02ConfigSavedDoneCB(cb) { }

    };

    virtual void async_rtrmgr_client_0_2_config_saved_done
       (
	const bool&	success,
	const string&	errmsg,
	RtrmgrClient02ConfigSavedDoneCB);
#endif

    virtual XrlCmdError rtrmgr_client_0_2_config_change_done(
	// Input values,
	const bool&	success,
	const string&	errmsg) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    RtrmgrClient02ConfigChangeDoneRF;

    class RtrmgrClient02ConfigChangeDoneCB {
        RtrmgrClient02ConfigChangeDoneRF cb;

    public:
        operator const RtrmgrClient02ConfigChangeDoneRF& () const { return cb; }
        const RtrmgrClient02ConfigChangeDoneRF& operator ->() const { return cb; }
        RtrmgrClient02ConfigChangeDoneCB(const RtrmgrClient02ConfigChangeDoneRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct RtrmgrClient02ConfigChangeDoneRsp :
      public RtrmgrClient02ConfigChangeDoneCB {
        RtrmgrClient02ConfigChangeDoneRsp(const RtrmgrClient02ConfigChangeDoneRF& cb)
          : RtrmgrClient02ConfigChangeDoneCB(cb) { }

    };

    virtual void async_rtrmgr_client_0_2_config_change_done
       (
	const bool&	success,
	const string&	errmsg,
	RtrmgrClient02ConfigChangeDoneCB);
#endif

    virtual XrlCmdError rtrmgr_client_0_2_config_changed(
	// Input values,
	const uint32_t&	userid,
	const string&	deltas,
	const string&	deletions) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    RtrmgrClient02ConfigChangedRF;

    class RtrmgrClient02ConfigChangedCB {
        RtrmgrClient02ConfigChangedRF cb;

    public:
        operator const RtrmgrClient02ConfigChangedRF& () const { return cb; }
        const RtrmgrClient02ConfigChangedRF& operator ->() const { return cb; }
        RtrmgrClient02ConfigChangedCB(const RtrmgrClient02ConfigChangedRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct RtrmgrClient02ConfigChangedRsp :
      public RtrmgrClient02ConfigChangedCB {
        RtrmgrClient02ConfigChangedRsp(const RtrmgrClient02ConfigChangedRF& cb)
          : RtrmgrClient02ConfigChangedCB(cb) { }

    };

    virtual void async_rtrmgr_client_0_2_config_changed
       (
	const uint32_t&	userid,
	const string&	deltas,
	const string&	deletions,
	RtrmgrClient02ConfigChangedCB);
#endif

    virtual XrlCmdError rtrmgr_client_0_2_module_status(
	// Input values,
	const string&	modname,
	const uint32_t&	status) = 0;
#ifdef XORP_ENABLE_ASYNC_SERVER
    typedef
    XorpCallback1<void, const XrlCmdError &>::RefPtr
    RtrmgrClient02ModuleStatusRF;

    class RtrmgrClient02ModuleStatusCB {
        RtrmgrClient02ModuleStatusRF cb;

    public:
        operator const RtrmgrClient02ModuleStatusRF& () const { return cb; }
        const RtrmgrClient02ModuleStatusRF& operator ->() const { return cb; }
        RtrmgrClient02ModuleStatusCB(const RtrmgrClient02ModuleStatusRF& cb)
          : cb(cb) { }

        void fail(const XrlCmdError &e) const { cb->dispatch(e); }

        void respond() const {
            cb->dispatch(XrlCmdError::OKAY());
        }
    };

    struct RtrmgrClient02ModuleStatusRsp :
      public RtrmgrClient02ModuleStatusCB {
        RtrmgrClient02ModuleStatusRsp(const RtrmgrClient02ModuleStatusRF& cb)
          : RtrmgrClient02ModuleStatusCB(cb) { }

    };

    virtual void async_rtrmgr_client_0_2_module_status
       (
	const string&	modname,
	const uint32_t&	status,
	RtrmgrClient02ModuleStatusCB);
#endif

private:
    XrlCmdRT handle_common_0_1_get_target_name(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_common_0_1_get_target_name
       (const XrlCmdError &e,
	const string* arg_name,
        XrlRespCallback);
#endif

    XrlCmdRT handle_common_0_1_get_version(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_common_0_1_get_version
       (const XrlCmdError &e,
	const string* arg_version,
        XrlRespCallback);
#endif

    XrlCmdRT handle_common_0_1_get_status(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_common_0_1_get_status
       (const XrlCmdError &e,
	const uint32_t* arg_status,
	const string* arg_reason,
        XrlRespCallback);
#endif

    XrlCmdRT handle_common_0_1_shutdown(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_common_0_1_shutdown
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_common_0_1_startup(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_common_0_1_startup
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_rtrmgr_client_0_2_new_config_user(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_rtrmgr_client_0_2_new_config_user
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_rtrmgr_client_0_2_config_saved_done(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_rtrmgr_client_0_2_config_saved_done
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_rtrmgr_client_0_2_config_change_done(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_rtrmgr_client_0_2_config_change_done
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_rtrmgr_client_0_2_config_changed(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_rtrmgr_client_0_2_config_changed
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    XrlCmdRT handle_rtrmgr_client_0_2_module_status(const XrlArgs& in, XrlCmdOT out);
#ifdef XORP_ENABLE_ASYNC_SERVER
    void callback_rtrmgr_client_0_2_module_status
       (const XrlCmdError &e,
        XrlRespCallback);
#endif

    void add_handlers();
    void remove_handlers();

    struct handler_table {
        const char *name;
        XrlCmdRT (XrlXorpshTargetBase::*method)(const XrlArgs&, XrlCmdOT);
    };

    static const struct handler_table handlers[];
    static const size_t num_handlers;
};

#endif // __XRL_TARGETS_XORPSH_BASE_HH__
